const log       = require('color-logs')(true, true, "Categorie.class.js");

var id,
    title,
    uri,
    articles,
    description;

class Categorie {
    
    /**
     * 
     * @param {string} title : title of categorie
     * @param {string} uri : uri of categorie
     * @param {string} description : description of categorie
     */
    constructor(id, title, uri, description){
        this.setId(id);
        this.setTitle(title);
        this.setUri(uri);
        this.setDescription(description);
        this.articles = new Array();
    } 
    
    setId(id){
        this.id = id;
    }
    
    setTitle(title){
        this.title = title;
    }
    
    setUri(uri){
        this.uri = uri;
    }
    
    setDescription(description){
        this.description = description;
    }
    
    /**
     * 
     * @param {object <Article>} article : array of article object owned by this categorie
     */
    setArticle(article){
        this.articles.push(article);
    }
    
    getId(){
        return this.id;
    }
    
    /**
     * 
     * @returns {string} title of categorie
     */
    getTitle(){
        return this.title;
    }
    
    /**
     * 
     * @returns {string} uri of categorie
     */
    getUri(){
        return this.uri;
    }
    
    /**
     * 
     * @returns {string} description of categories
     */
    getDescription(){
        return this.description;
    }
    
    /**
     * 
     * @returns {array} article array of categories
     */
    getArticles(){
        return this.articles;
    }
}

module.exports = Categorie;